---
layout: handbook-page-toc
title: Global Search Team
description: "The Global Search team is focused on bringing world class search functionality to GitLab.com and self-managed instances."
---
## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

## Vision

The Global Search team is focused on bringing world class search functionality to GitLab.com and self-managed instances.

## Mission

The team will be responsible for improving and expanding upon our current global search implementations using Elasticsearch, PostgreSQL, and Gitaly. Areas of responsibility will include global search functionality, UI, ingestion mechanisms, optimal indexing, administrative tools and installation mechanisms for self-managed installations.

This team doesn't own custom searches for specific features, such as the "filter bar" on issues which is part of the [Issue Tracking](https://about.gitlab.com/direction/plan/issue_tracking/) category owned by the [Project Management group](/handbook/product/categories/#project-management-group).

## Team Members

The following people are permanent members of the Global Search Team:

<%= direct_team(manager_slug: 'cliu', role_regexp: /Global Search|Enablement/) %>

## Stable Counterparts

The following members of other functional teams are our stable counterparts:

<%= stable_counterparts(role_regexp: /Global Search|Enablement.*Search/, direct_manager_role: 'Backend Engineering Manager, Global Search and Memory') %>

## Meetings

Whenever possible, we prefer to communicate asynchronously using issues, merge requests, and Slack. However, face-to-face meetings are useful to establish personal connection and to address items that would be more efficiently discussed synchronously such as blockers.

- The Global Search Team meets weekly on Tuesdays alternately at 14:30 UTC and 21:30 UTC.

## Work

We follow the general workflow and principles defined in [Product Development Flow](/handbook/product-development-flow/) and [Engineering Workflow](/handbook/engineering/workflow/). To bring an issue to our attention please create an issue in the relevant project. Add the `~"group::global search"` label along with any other relevant labels. If it is an urgent issue, please reach out to the Product Manager or Engineering Manager listed in the [Stable Counterparts](/handbook/engineering/development/enablement/search/#stable-counterparts) section above.

Below are a few guidelines the team follows in the day-to-day work.

- We use asynchronous communication with each other and with other GitLab teams most of the time via GitLab, Slack, Google Docs, etc.
- We have weekly team meetings, 1-on-1 meetings and virtual happy hours via Zoom to discuss various topics and to create team bonding.
- We encourage all backend engineers in our team to get a review of their changes by someone else in our team. It's great for knowledge sharing.

* We organize our tasks under Epics and Issues. Product Manager and Engineering Manager go through backlog at the planning phase of each release and put issues into next one or two milestones. The issues on the [milestone board](https://gitlab.com/groups/gitlab-org/-/boards/1339901?label_name[]=group%3A%3Aglobal%20search) are sorted based on priority. The higher priority issues are put on the top.
* We work with the UX team for features that need their design input by labeling the issues with a UX workflow label and adding the corresponding UX team counterpart as assignee. We use `workflow::problem validation` and `workflow::solution` validation for user research, and `workflow::design` for UI design and prototyping. Once the design is finished, `workflow::ready for development` label will be added as an indicator that development can start. For minor UX/UI changes, we contact our UX counterpart or the UX manager to request a review for fast iterations.
* We work with Quality team for issues that require input from testing perspective by labeling the issues with `workflow::planning breakdown` and adding the SET counterpart as assignee. Once SET reviews the issue, they acknowledge back with label [`quad-planning::complete-action` or `quad-planning::complete-no-action`](/handbook/product-development-flow/#build-phase-1-plan)
* We work with Technical Writing team for issues that need documentation change by labeling the issues with `documentation` and adding our counterpart in Technical Writing team as assignee. Our technical writer helps us update the corresponding document. The documentation change normally happens together with code change.
* We work with our stable counterpart in Security team for issues that need input from security perspective. We suggest to use team planning issue, for example [this one](https://gitlab.com/gitlab-org/search-team/team-tasks/-/issues/17), for communication.
* We work with Support Engineering team by collaborating on issues directly. We invite our counterpart in Support Engineering team in our team meeting every month to have direct communication.
* When team members are ready for their next tasks, they will pick the issue from the top of milestone board and become the issue owner by assigning the issue to themselves. The issue owner will be responsible for finding the solution of the issue. They can find a solution by a Merge Request. They can also break down the issue into smaller sub issues if it makes sense to take an iterative approach.
* Prior to going out of office for an extended period of time, assign items still in review to the Engineering Manager. The Engineering Manager can reassign as needed.
* Whenever a team member reviews the work of an author that is out of office for an extended period of time, they are welcome to complete the changes requested if they deem themselves comfortable with the remainder of the work.
* We review and prioritize bugs every week. It is common for bugs to represent the problem without identifying the impact. Because the Product Management and QA share the responsibility of assessing every bug for priority and severity and details. Severity uses an approximation of the Risk Matrix to identify potential risk and frequency. Priority is based on total impact over time. Occasionally, something of a lower priority/ severity will be added to a milestone when it has a relationship to work currently scheduled.
  1. Review all new bugs for content, priority, severity, and milestones
  1. Review any bugs missing priority or severity
  1. Prioritize bugs for the current milestone. 10% of scheduled work should be focused on bugs 
  1. Schedule bugs for future milestones based on capacity, severity, priority, and relationship to any scheduled work

### Advanced Global Search Rollout on GitLab.com

The team has been actively working on enabling Elasticsearch powered Advanced Search on GitLab.com. [Based on our analysis](https://gitlab.com/groups/gitlab-org/-/epics/1736), we set our first target to rolling this feature out for all the paid groups on GitLab.com. You can find more details about the timeline and progress in the links below.

- [Plan of Advanced. Search Rollout on GitLab.com](https://gitlab.com/groups/gitlab-com/-/epics/649)
- [Steps and Enhancements of Advanced Search Rollout on GitLab.com](./es-rollout-timeline.html)

### Severity Labels for Search Issues (`~advanced search`, `~global search`)

| Type of Operation | `~severity::1` - Blocker | `~severity::2` - Critical | `~severity::3` - Major  | `~severity::4` - Low |
| Recall Record, Global | Above 10 seconds to timing out | Between 7 and 10 seconds | Between 4 and 7 seconds | Between 2 and 4 seconds |
| Time until inserted record is recallable | Above 15 minutes | Between 15 and 10 minutes | Between 10 and 5 minutes | Between 3 and 5 minutes|

The two types of operations we detail severity metrics for above are:
- Recall Record, Global: This is the time it takes to recall a record using a globally scoped search of GitLab.com. Records could be entities such as: projects, users, groups, etc.
- Time until inserted record is recallable: This is the elapsed time between adding a new record and having that new record be recallable via a search. This process depends on many underlying technologies such as the [Go indexer](https://gitlab.com/gitlab-org/gitlab-elasticsearch-indexer), [Sidekiq queues](https://docs.gitlab.com/ee/development/elasticsearch.html#how-does-it-work), and the Elasticsearch database.

### Weighting for Search Issues

We use the Fibonacci rating system to assign weights to Search issues. Below are a few guidelines when assigning issue weight:

* Issues that include `~backend` and `~frontend` work should have the weights added for a total weight representative of the work effort.
* Spike issues are assigned a weight to help timebox the effort.
* Bugs will not be assigned a weight.
* Any issue weighted over 5 should be broken down into smaller iterative steps if the issue does not contain `~backend` and `~frontend` work.

| Weight | Description |
|--------|--------|
| 0      | No effort or trivial effort (example: Documentation typo or Feature Flag Rollout) |
| 1      | Low effort (No Database migrations or Advanced Search migrations) |
| 2      | Low-Medium effort |
| 3      | Medium effort |
| 5      | High effort |

### Common Links

* [Global Search Team Milestone Board](https://gitlab.com/groups/gitlab-org/-/boards/1339901?label_name[]=group%3A%3Aglobal%20search)
* [Global Search Team Workflow Board](https://gitlab.com/groups/gitlab-org/-/boards/1584459?label_name[]=group%3A%3Aglobal%20search)
* [Global Search Team Epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Aglobal%20search)
* Global Search team slack channel (internal) [#g_global_search](https://gitlab.slack.com/app_redirect?channel=g_global_search)
* [Global Search Roadmap](https://gitlab.com/groups/gitlab-org/-/roadmap?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Aglobal%20search&label_name[]=Roadmap)
* [Bug Review Board](https://gitlab.com/groups/gitlab-org/-/boards/2118530?label_name[]=bug&label_name[]=group%3A%3Aglobal%20search)

## Resources

### Documentations

- [GitLab ElasticSearch Knowledge page](https://docs.gitlab.com/ee/development/elasticsearch.html)
- [GitLab ElasticSearch Integration](https://docs.gitlab.com/ee/integration/elasticsearch.html)
- [GDK Elasticsearch Setup Instructions](https://gitlab.com/gitlab-org/gitlab-development-kit/-/blob/master/doc/howto/elasticsearch.md)

### Blog Posts

- [Lessons from our journey to enable global code search with Elasticsearch on GitLab.com](https://about.gitlab.com/blog/2019/03/20/enabling-global-search-elasticsearch-gitlab-com/)
- [Update: The challenge of enabling Elasticsearch on GitLab.com](https://about.gitlab.com/releases/2019/07/16/elasticsearch-update/)
- [Update: Elasticsearch lessons learnt for Advanced Global Search 2020-04-28](https://about.gitlab.com/blog/2020/04/28/elasticsearch-update/)
- [How the Search Team at GitLab Implemented a Risk Map to Direct Automated Testing Efforts](https://about.gitlab.com/blog/2020/09/03/risk-mapping/)
- [GitLab's data migration process for Advanced Search](https://about.gitlab.com/blog/2021/06/01/advanced-search-data-migrations/)

### Product Demos

- [GitLab search with Custom Search Engines](https://www.youtube.com/watch?v=YESlLDxHH4o)
- [Use the GitLab search bar to navigate](https://www.youtube.com/watch?v=OE9b0Qc6KaI)
- [Search suggestions for recently viewed issues and merge requests](https://www.youtube.com/watch?v=_5s4ZjnDZPo)
- [How to search for epics in GitLab](https://www.youtube.com/watch?v=bu6kaBqcYFc)
- [Elasticsearch Migrating Issues To Separate Index Technical Overview](https://youtu.be/1znFvPH_wjU)
